# detect if building under mandrake 8.2
%define mdk82 %(LC_ALL=C awk '{print ($4 <= 8.2)}' /etc/mandrake-release)
# detect if building under mandrake 9.0
%define mdk92 %(LC_ALL=C awk '{print ($4 >= 9.2)}' /etc/mandrake-release)

%define name naat-backend
%define version 0.8
%define release %mkrel 38

%define adminroot /home/admin

Summary: Backend for Mandriva firewall admin tool
Name: %{name} 
Version: %{version}
Release: %{release}
Source0: %{name}-%{version}.tar.bz2
License: GPL
Url:		http://www.mandrakesecure.net
Group: System/Configuration/Other
#BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-buildroot

Requires(pre): coreutils
Requires(post): coreutils
Requires(postun): coreutils
Requires(post): sudo
Requires(postun): sudo
requires(post): perl
requires(postun): perl
Requires: perl-Text-Template
Requires: drakxtools-newt >= 1.1.7-43mdk
Requires: newt
BuildRequires: /bin/chmod
BuildRequires: perl-devel >= 5.6.0
BuildRequires: librrdtool-devel

%if %{mdk92} 
%define _requires_exceptions perl(Data::Dumper)\\|perl(Exporter)\\|perl(File::Basename)\\|perl(File::Path)\\|perl(Getopt::Long)\\|perl(POSIX)\\|perl(Text::Template)\\|perl(any)\\|perl(backend::config)\\|perl(backend::util)\\|perl(common)\\|perl(detect_devices)\\|perl(ethernet_info)\\|perl(isdn)\\|perl(lib)\\|perl(modules)\\|perl(netconnect)\\|perl(network)\\|perl(network::ethernet)\\|perl(network::isdn)\\|perl(network::modem)\\|perl(rpmtools)\\|perl(strict)\\|perl(urpm)\\|perl(vars)
%endif

%description
Backend for Mandriva firewall admin tool.
Contains an event-handler, a config-wrapper (usable in 
commandline), as well as a sample configuration, and 
base templates, events, and scripts.

%package devel
Summary: Development package of the backend-end in NAAT project
Group: Development/Other
Requires: perl-devel >= 5.6.0
Requires: librrdtool0-devel
Requires: rpm-devel
Requires: rpm-build
Requires: /bin/chmod
Requires: gcc
Requires: make

%description devel
A set of development tools of the 
Network Appliance Administration Tool on Mandriva Linux Server.

%prep
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%setup -q
mkdir -p ${RPM_BUILD_DIR}/%{name}-devel/
tar -jxf ${RPM_SOURCE_DIR}/%{name}-%{version}.tar.bz2 -C ${RPM_BUILD_DIR}/%{name}-devel/

%build
%make
cp runtime/config-wrapper.pl runtime/config-wrapper.orig.pl
cp runtime/config-test.pl runtime/config-test.orig.pl
#mv runtime/config-wrapper.pl.bin runtime/config-wrapper.pl
#mv runtime/config-test.pl.bin runtime/config-test.pl

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT
%makeinstall DESTDIR=$RPM_BUILD_ROOT
cp runtime/*.orig.pl $RPM_BUILD_ROOT%{_bindir}

mkdir -p $RPM_BUILD_ROOT%{_prefix}/src/%{name}-devel
cp -dpR ${RPM_BUILD_DIR}/%{name}-devel/* $RPM_BUILD_ROOT%{_prefix}/src/%{name}-devel/

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%pre
# Add Naat console in /etc/shells
grep -qw 'naat-console' /etc/shells  || \
	echo "/usr/bin/naat-console" >> /etc/shells

# Add admin group exist if doesn't exit
grep -q '^admin:' /etc/group || \
	/usr/sbin/groupadd admin 2> /dev/null


# Add the admin user (for console) if doesn't exist
grep -q '^admin:' /etc/passwd  || \
	/usr/sbin/useradd -c "Administrator"  -g admin -G adm -d /home/admin \
	-s /usr/bin/naat-console admin 2> /dev/null

# Backup the configuration file
if [ "$1" = "2" ]; then
		cp -fp /var/lib/naat/configuration /var/lib/naat/configuration.rpmbackup;
fi


%post
# add sudoers entry
/bin/chmod a+w /etc/sudoers
grep -q '%admin' /etc/sudoers || \
echo "%admin ALL=(ALL) NOPASSWD: /usr/bin/event-handler.pl , /usr/share/naat/scripts/*" >> /etc/sudoers;
grep -q 'Defaults !syslog' /etc/sudoers || echo 'Defaults !syslog' >> /etc/sudoers
/bin/chmod 0440 /etc/sudoers

# Restore the values stored in the previous configuration file
if [ "$1" = "2" ]; then
    perl -n -e 'if (!defined ($read) ) {
						open (CONFIG, "/var/lib/naat/configuration.rpmbackup") or 	die "Can t open config file: $!"; 
						while (<CONFIG>) {  
								chomp; s/\#.*//; s/^\s+//; s/\s+$//; next unless length;  
								($var, $value) = split(/\s*=\s*/, $_, 2); 
								$hash{$var} = $value; 
						} 
						close (CONFIG); 
						$read = "true";
				}
				$line = $_;
				chomp; s/\#.*//; s/^\s+//; s/\s+$//;
				if (length) {
						($var, $value) = split(/\s*=\s*/, $_, 2);
						if ($value !~ /(get:|set:)/ && exists $hash{$var} ) {
							$line = "$var=$hash{$var}\n";	
						} 
				}
				print $line;
			' -i /var/lib/naat/configuration;
fi

%postun 
# it it's a full uninstall
if [ "$1" = "0" ]; then
# remove sudoers entry
/bin/chmod a+w /etc/sudoers
grep -q '%admin' /etc/sudoers && \
	perl -ni -e 'print unless m!^%admin.*!' /etc/sudoers;
/bin/chmod 0440 /etc/sudoers
grep -q 'Defaults !syslog' /etc/sudoers && \
	perl -ni -e 'print unless m/^Defaults !syslog/' /etc/sudoers

# Remove Naat console from /etc/shells
perl -ni -e 'print unless m!/usr/bin/naat-console.*!' /etc/shells

fi

%files
%defattr(-,root,root)
%doc README configuration.README COPYRIGHT AUTHORS GPL ChangeLog
%dir %{_sysconfdir}/naat
%config(noreplace) %{_sysconfdir}/naat/*
%config(noreplace) %{_sysconfdir}/pingtest.conf
%dir %attr(2770,root,admin) %{_localstatedir}/naat
%attr(660,root,admin) %{_localstatedir}/naat/*
%attr(755,root,root) %{_bindir}/*
%attr(755,root,root) %{_sbindir}/*
%{_prefix}/lib/naat
%{_datadir}/naat

%files devel
%defattr(-,root,root)
%doc README configuration COPYRIGHT AUTHORS GPL ChangeLog
%dir %{_prefix}/src/%{name}-devel
%{_prefix}/src/%{name}-devel/*

%changelog
* Tue Nov 07 2006 Neverstopdreaming <neverstopdreaming@gmail.com> 0.8-38pclos2007
- Build for PCLinuxOS 2007

